﻿' -----------------------------------------------------------------------------------------
'
' DreipunktunvVB                                                    Ulrich Müller  01.12.09
'                                                                   Aspire  VB 2005 Express
' Dreipunktregelung - Version mit Klasse FishFace
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFaceTX

Public Class DreipunktunvVB

	Dim tx As New FishFace()
	Dim ReglerMotor As Mot = Mot.M1
	Dim LichtSensor As Unv = Unv.I4
	Dim LichtQuelle As Out = Out.O7

	Dim Sollwert, LimitHigh, LimitLow, ActualValue As Integer

	Private Sub numSollWert_ValueChanged(ByVal sender As System.Object, _
					ByVal e As System.EventArgs) Handles numSollWert.ValueChanged
		Sollwert = numSollWert.Value
		LimitHigh = Sollwert + 100
		LimitLow = Sollwert - 100
	End Sub

	Private Sub Action()
		numSollWert.Value = 700
		tx.SetLamp(LichtQuelle, Dir.On)
		tx.Pause(1234)
		Do
			ActualValue = tx.GetAnalog(LichtSensor)
			lblIstwert.Text = ActualValue.ToString()
			If ActualValue < LimitLow Then
				tx.SetMotor(ReglerMotor, Dir.Right, 400)
			ElseIf ActualValue > LimitHigh Then
				tx.SetMotor(ReglerMotor, Dir.Left, 400)
			Else
				tx.SetMotor(ReglerMotor, Dir.Off)
			End If
			tx.Pause(111)
		Loop Until tx.Finish()
	End Sub

#Region "--- ProgramControl ---"
	Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
	Handles cmdAction.Click
		' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
		'     während des Ablaufs von Action gesperrt
		Try
			tx.OpenController(txtComName.Text)
			cmdAction.Enabled = False
			cmdEnde.Text = "&HALT"
			lblStatus.Text = "--- Bei der Arbeit ---"
			Action()					' --- Nutz-Routine für die Anwendung
		Catch tx As FishFaceException
			MsgBox(tx.Message)
		Finally
			tx.CloseController()
			cmdAction.Enabled = True
			cmdEnde.Text = "&ENDE"
			lblStatus.Text = "--- Auf ein Neues ---"
			cmdEnde.Focus()
		End Try
	End Sub

	Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
		' --- Programmende nur, wenn Action nicht läuft ---
		If cmdEnde.Text = "&HALT" Then tx.NotHalt = True Else Me.Close()
	End Sub

	Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
		If cmdEnde.Text = "&HALT" Then e.Cancel = True
	End Sub

#End Region

End Class
