﻿' -----------------------------------------------------------------------------------------
'
' RobRechnerSimpleVB                                                Ulrich Müller  02.12.08
'                                                                   Aspire  VB 2005 Express
' Kleine Rechenaufgaben, Kontrolle der Lösung über Taschenrechner
'     Nutzung FishFaceTX.DLL - Klasse FishFaceTX
' Belegung Interface :
' X-Achse : M1 (EncoderMotor), I1(Endtaster), C1(Impuls)
' Y-Achse : M2 (EncoderMotor), I2(Endtaster), C2(Impuls)
' Taster  : M3 (XS-Motor),     I3(Endtaster)
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFaceTX

Public Class RobRechnerSimpleVB

	Dim tx As New FishFace()
	Const xMotor As Mot = Mot.M1
	Const yMotor As Mot = Mot.M2
	Const taster As Mot = Mot.M3
	Const tEnd As Unv = Unv.I3

	Const txFull As Integer = 512
	Const xMax As Integer = 1040
	Dim xStart As Integer = 0
	Dim xDest As Integer = 0
	Const yMax As Integer = 1040
	Dim yStart As Integer = 0
	Dim yDest As Integer = 0

	Dim TasPos(,) As Integer = {{940, 310}, {820, 310}, {820, 590}, {820, 770}, {660, 370}, _
	{660, 590}, {660, 770}, {530, 370}, {530, 590}, {530, 770}, {940, 1010}, {940, 770}, _
	{940, 180}}

	Private Sub TasterGo()
		tx.SetMotor(taster, Dir.Right)
		tx.WaitForInput(tEnd)
		tx.SetMotor(taster, Dir.Left)
		tx.Pause(555)
		tx.SetMotor(taster, Dir.Off)
	End Sub
	Private Sub MoveHome()
		xDest = 0
		yDest = 0
		tx.StartRobMotor(xMotor, Dir.Left, txFull, 9999)
		tx.StartRobMotor(yMotor, Dir.Left, txFull, 9999)
		tx.WaitForMotors(xMotor, yMotor)
		xStart = 0
		yStart = 0
	End Sub
	Private Sub MoveTo(ByVal x As Integer, ByVal y As Integer)
		Dim diff As Integer = 1
		Dim vorzX As Integer = 1
		Dim vorzY As Integer = 1
		If x > xMax Then xDest = xMax Else xDest = x
		If xDest > xStart Then
			tx.StartMotor(xMotor, Dir.Right, txFull, xDest - xStart)
			vorzX = 1
		ElseIf xStart - xDest > 0 Then
			tx.StartRobMotor(xMotor, Dir.Left, txFull, xStart - xDest)
			vorzX = -1
		End If
		If y > yMax Then yDest = yMax Else yDest = y
		If yDest > yStart Then
			tx.StartMotor(yMotor, Dir.Right, txFull, yDest - yStart)
			vorzY = 1
		ElseIf yStart - yDest > 0 Then
			tx.StartRobMotor(yMotor, Dir.Left, txFull, yStart - yDest)
			vorzY = -1
		End If
		diff = tx.WaitForMotor(xMotor)
		xStart = xDest + diff * vorzX
		diff = tx.WaitForMotor(yMotor)
		yStart = yDest + diff * vorzY
	End Sub

	Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
	Handles cmdAction.Click
		Dim OP1, OP2 As Integer
		Dim i, ptrTas As Integer
		Dim Tasten(24) As Integer
		Try
			If cmdAction.Text = "START" Then
				tx.OpenController(txtComName.Text)
				cmdEnde.Text = "&HALT"
				lblStatus.Text = "--- Fährt auf Home-Position ---"
				TasterGo()
				MoveHome()
				MoveTo(TasPos(12, 0), TasPos(12, 1))
				TasterGo()
				lblStatus.Text = "Gestartet"
				cmdEnde.Text = "ENDE"
				cmdAction.Text = "Lösung"
				cmdEnde.Focus()
			ElseIf cmdAction.Text = "Lösung" Then
				OP1 = txtOP1.Text
				OP2 = txtOP2.Text
				ptrTas = 0
				Tasten(ptrTas) = 12	 ' --- Clear
				For i = 0 To txtOP1.Text.Length - 1
					ptrTas += 1
					Tasten(ptrTas) = txtOP1.Text.Substring(i, 1)
				Next
				ptrTas += 1
				Tasten(ptrTas) = 10		' --- Plus
				For i = 0 To txtOP2.Text.Length - 1
					ptrTas += 1
					Tasten(ptrTas) = txtOP2.Text.Substring(i, 1)
				Next
				ptrTas += 1
				Tasten(ptrTas) = 11		' --- Gleich
				cmdEnde.Text = "HALT"
				lblStatus.Text = "Kontrolle mit dem Taschenrechner"
				For i = 0 To ptrTas
					MoveTo(TasPos(Tasten(i), 0), TasPos(Tasten(i), 1))
					TasterGo()
				Next
				txtErgebnis.Text = OP1 + OP2
				lblStatus.Text = "OK, das war's"
				cmdEnde.Text = "ENDE"
			End If
		Catch tx As FishFaceException
			MsgBox(tx.Message)
		Catch ee As Exception
			lblStatus.Text = ee.Message
		End Try
	End Sub

	Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
		If cmdEnde.Text = "&HALT" Then
			tx.NotHalt = True
		Else
			tx.CloseController()
			Me.Close()
		End If
	End Sub

	Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		If cmdEnde.Text = "&HALT" Then
			e.Cancel = True
		Else
			tx.CloseController()
		End If
	End Sub

End Class
